/*

  This file is part of sniffer, a packet capture utility and
  network moniter
  The author can be contacted at <mistral@stev.org>
  the lastest version is avilable from 
  http://stev.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
	$Id: arp.h,v 1.1 2009/05/06 17:07:00 james.stevenson Exp $

*/

#ifndef _SNIFF_IF_ARP_H
#define _SNIFF_IF_ARP_H

#ifdef ARP

#include <sys/socket.h>
#include <sys/types.h>

#include <linux/in.h>
#include <linux/if.h>
#include <linux/if_arp.h>

#include "sniff.h"

extern FILE *arp_log;
extern pthread_mutex_t arp_mutex;
extern struct gen_stat arp_stat;

extern int arp_handle	(struct sniff_pkt *pkt);
extern int arp_tidy	( void );
extern int arp_init	( void );

#endif	/* ARP */
#endif	/* _SNIFF_IF_ARP_H */

