/*

  This file is part of sniffer, a packet capture utility and
  network moniter
  The author can be contacted at <mistral@stev.org>
  the lastest version is avilable from 
  http://stev.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
	$Id: http.h,v 1.1 2009/05/06 17:07:01 james.stevenson Exp $

*/

#ifndef _SNIFF_HTTP_H
#define _SNIFF_HTTP_H

#include "config.h"
#include "list.h"
#include "tcp.h"

#ifdef HTTP

#define HTTPMAXBUF	4196
#define HTTPMAXTAG	4196

struct http_data {
   struct list_t *tags;
};

extern pthread_mutex_t http_mutex;

#ifdef _SNIFF_TCP_H
void http_src		(struct sniff_pkt *pkt, struct tcp_data *tcp , char *data , int length );
void http_dst		(struct sniff_pkt *pkt, struct tcp_data *tcp , char *data , int length );
void http_clean		(struct tcp_data *tcp );
void http_init		(struct tcp_data *tcp );
void http_open		( void );
#endif

#endif /* ifdef HTTP */

#endif /* _SNIFF_HTTP_H */

