/*

  This file is part of sniffer, a packet capture utility and
  network moniter
  The author can be contacted at <mistral@stev.org>
  the lastest version is avilable from 
  http://stev.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
	$Id: log.h,v 1.1 2009/05/06 17:07:01 james.stevenson Exp $

*/

#ifndef _SNIFF_LOG_H
#define _SNIFF_LOG_H

extern int log_fd;

extern void log_debug 		(const char *fmt , ... );
extern void log_error		(const char *fmt , ... );
extern void log_error_nolock	(const char *fmt , ... );
extern void log_start		( void );

/* where x is the name of the system call */
#define log_errno(x) log_error("$s:%d\t %s() %s\n", __FILE__, __LINE__, x, strerror(errno))
#define log_errno_nolock(x) log_error_nolock("%s:%d\t%s() %s\n", __FILE__, __LINE__, x, strerror(errno))

#define log_err(x) log_error("%s:%d\t%s\n", __FILE__, __LINE__, x)
#define log_unreach() log_error("Unreachable Code %s:%d\n", __FILE__, __LINE__)

/* simple logging system prints a line of text */
#define log_s(x) log_error("%s:%d\t%s\n", __FILE__, __LINE__, x)


#endif
