/*

  This file is part of sniffer, a packet capture utility and
  network moniter
  The author can be contacted at <mistral@stev.org>
  the lastest version is avilable from 
  http://stev.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
	$Id: stat.h,v 1.1 2009/05/06 17:07:02 james.stevenson Exp $

*/

#ifndef _SNIFF_STAT_H
#define _SNIFF_STAT_H

struct gen_stat {
	char *title;
	unsigned long long packets;
	unsigned long long bytes;
	unsigned long long dropped;
	unsigned long long old_packets;
	unsigned long long old_bytes;
	unsigned long long old_dropped;
	unsigned long long readable;
	char *messure; /* string for the size of the dat in readable */
	float rate_packets;
	float rate_kb;
	float avg_packets;
	float avg_kb;
	time_t last; /* the last time this was called used in rate calcs */
	time_t init; /* time we started messuring */
};


extern struct gen_stat stat_global;

void init_stat		(struct gen_stat *stat, char *title);
void stat_process		(struct gen_stat *stat );


#endif /* _SNIFF_STAT */

