/*

  This file is part of sniffer, a packet capture utility and
  network moniter
  The author can be contacted at <mistral@stev.org>
  the lastest version is avilable from 
  http://stev.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	$Id: tidy.c,v 1.1 2009/05/06 17:07:00 james.stevenson Exp $

*/

#include "config.h"

#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

#include "sniff.h"
#include "list.h"


struct list_t *tidy_list;

int tidy_init( void ) {
	tidy_list = list_init();
	return 0;
}

int tidy_register(void *func) {
	int err;
	list_LOCK(tidy_list);
	err = list_add(tidy_list, func);
	list_UNLOCK(tidy_list);
	return err;
}

int tidy( void ) {
	int i;
	void (*func) (void);

	while(1) {
		sleep(2);
		list_LOCK(tidy_list);
		for(i=0;i<list_len(tidy_list);i++) {
			func = list_get(tidy_list, i);
			if (func)
				func();
			list_UNLOCK(tidy_list);
			list_LOCK(tidy_list);
		}
		list_UNLOCK(tidy_list);
		fflush(NULL);
	}
	return 0;
}

